This website contains ALL LeetCode **Premium** problems for
**FREE!!**.

All leaked interview problems are collected from Internet.

All leaked interview problems are collected from Internet.

Given *n* non-negative integers *a _{1}*,

Note: You may not slant the container and *n* is at least 2.

b'

\n## Summary

\n## Solution

\n

\n#### Approach #1 Brute Force [Time Limit Exceeded]

\n

\n#### Approach #2 (Two Pointer Approach) [Accepted]

\n\n\n

'
\n\n

\nWe have to maximize the Area that can be formed between the vertical lines using the shorter line as length and the distance between the lines as the width of the rectangle forming the area.

\n\n

**Algorithm**

In this case, we will simply consider the area for every possible pair of the lines and find out the maximum area out of those.

\n\n**Complexity Analysis**

- \n
- Time complexity : . Calculating area for all height pairs. \n
- Space complexity : . Constant extra space is used. \n

\n

**Algorithm**

The intuition behind this approach is that the area formed between the lines will always be limited by the height of the shorter line. Further, the farther the lines, the more will be the area obtained.

\nWe take two pointers, one at the beginning and one at the end of the array constituting the length of the lines. Futher, we maintain a variable to store the maximum area obtained till now. At every step, we find out the area formed between them, update and move the pointer pointing to the shorter line towards the other end by one step.

\nThe algorithm can be better understood by looking at the example below:

\n1 8 6 2 5 4 8 3 7\n

!?!../Documents/11_Container_Water.json:1000,563!?!

\nHow this approach works?

\nInitially we consider the area constituting the exterior most lines. Now, to maximize the area, we need to consider the area between the lines of larger lengths. If we try to move the pointer at the longer line inwards, we won\'t gain any increase in area, since it is limited by the shorter line. But moving the shorter line\'s pointer could turn out to be beneficial, as per the same argument, despite the reduction in the width. This is done since a relatively longer line obtained by moving the shorter line\'s pointer might overcome the reduction in area caused by the width reduction.

\nFor further clarification click here and for the proof click here.

\n\n**Complexity Analysis**

- \n
- \n
Time complexity : . Single pass.

\n \n - \n
Space complexity : . Constant space is used.

\n \n

Analysis written by: @vinod23

\n